Bug 1176180 - [RFE] print 'addrgenmode' in detailed link information
Summary: [RFE] print 'addrgenmode' in detailed link information
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: iproute
Version: 7.2
Hardware: Unspecified
OS: Unspecified
high
high
Target Milestone: rc
: ---
Assignee: Pavel Šimerda (pavlix)
QA Contact: Jaroslav Aster
URL:
Whiteboard:
Depends On:
Blocks: 1205796 1110700 1191021 1251081
TreeView+ depends on / blocked
 
Reported: 2014-12-19 15:58 UTC by Thomas Haller
Modified: 2015-11-19 14:40 UTC (History)
3 users (show)

Fixed In Version: iproute-3.10.0-44.el7
Doc Type: Enhancement
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-11-19 14:40:39 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2015:2117 normal SHIPPED_LIVE iproute bug fix and enhancement update 2015-11-19 11:35:06 UTC

Description Thomas Haller 2014-12-19 15:58:04 UTC
Upstream commit https://git.kernel.org/cgit/linux/kernel/git/shemminger/iproute2.git/commit/?id=ff7c20844049be836c10087cb2418b99ff36ca2b added a way to set the addrgenmode via iproute.

However it does not show the current setting.


At least in the non-default case, it should print something like

# ip link show em1
2: em1: <NO-CARRIER,BROADCAST,MULTICAST,UP> mtu 1500 qdisc pfifo_fast state DOWN mode DEFAULT addrgenmode none group default qlen 1000
    link/ether aa:bb:cc:dd:ee:ff brd ff:ff:ff:ff:ff:ff

Comment 6 Pavel Šimerda (pavlix) 2015-04-15 15:52:14 UTC
I just realized that upstream has support for showing addrgenmode already:

ip -d link
1: lo: <LOOPBACK,UP,LOWER_UP> mtu 65536 qdisc noqueue state UNKNOWN mode DEFAULT group default 
    link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00 promiscuity 0 addrgenmode eui64

As seen above, it is only being shown when you request link details.

Comment 9 Pavel Šimerda (pavlix) 2015-04-16 13:07:06 UTC
The following commit was missing and a slightly adapted version of it was added:

commit ee0067a918e229cd0f3689364b4ce5eadbe3abdd
Author: Jiri Pirko <jiri@resnulli.us>
Date:   Thu Jan 8 09:49:55 2015 +0100

    iplink: print out addrgenmode attribute
    
    addrgenmode is currently write only by ip. So display this information
    if provided by kernel as well.
    
    Signed-off-by: Jiri Pirko <jiri@resnulli.us>

 ip/ipaddress.c | 26 ++++++++++++++++++++++++++
 1 file changed, 26 insertions(+)

The following commit was included already:

commit ff7c20844049be836c10087cb2418b99ff36ca2b
Author: Jiri Pirko <jiri@resnulli.us>
Date:   Fri Jul 11 21:11:46 2014 +0200

    iproute2: allow to ipv6 set address generation mode
    
    Signed-off-by: Jiri Pirko <jiri@resnulli.us>

 ip/iplink.c | 22 ++++++++++++++++++++++
 1 file changed, 22 insertions(+)

Comment 12 Pavel Šimerda (pavlix) 2015-04-16 21:27:38 UTC
(In reply to Thomas Haller from comment #0)
> # ip link show em1
> 2: em1: <NO-CARRIER,BROADCAST,MULTICAST,UP> mtu 1500 qdisc pfifo_fast state
> DOWN mode DEFAULT addrgenmode none group default qlen 1000
>     link/ether aa:bb:cc:dd:ee:ff brd ff:ff:ff:ff:ff:ff

Hi Thomas,

the upstream feature has been backported and 'ip -d link show' now works as expected. That is slightly different than what your bug report original said in that it is not done by default for 'ip link show'. If you still want this detail changed, please try to persuade upstream to accept such a change first.

Cheers,

Pavel

Comment 14 Thomas Haller 2015-04-17 07:37:35 UTC
(In reply to Pavel Šimerda (pavlix) from comment #12)
> (In reply to Thomas Haller from comment #0)
> > # ip link show em1
> > 2: em1: <NO-CARRIER,BROADCAST,MULTICAST,UP> mtu 1500 qdisc pfifo_fast state
> > DOWN mode DEFAULT addrgenmode none group default qlen 1000
> >     link/ether aa:bb:cc:dd:ee:ff brd ff:ff:ff:ff:ff:ff
> 
> Hi Thomas,
> 
> the upstream feature has been backported and 'ip -d link show' now works as
> expected. That is slightly different than what your bug report original said
> in that it is not done by default for 'ip link show'. If you still want this
> detail changed, please try to persuade upstream to accept such a change
> first.

no, that is ok.

It was only important to have a common system tool (iproute2) to be able to see the addrgenmode in some way. Requiring "-d" is fine.

Thank you.

Comment 15 Jaroslav Aster 2015-05-12 11:51:17 UTC
Hi,

the new build removed mention about addrgenmode from ip-link man page.

# rpm -q iproute
iproute-3.10.0-21.el7.x86_64

# man ip-link | col -b | grep 'addrgenmode'
               addrgenmode { eui64 | none }  }
       addrgenmode eui64 or addrgenmode none

# rpm -q iproute
iproute-3.10.0-26.el7.x86_64

# man ip-link | col -b | grep 'addrgenmode'

Comment 19 errata-xmlrpc 2015-11-19 14:40:39 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHBA-2015-2117.html


Note You need to log in before you can comment on or make changes to this bug.